export default ({Vue}) => {
    return {
        set(state, { collection, models }) {
            if (models instanceof Array) {
                Vue.set(state, collection, models)
            }
        },
        update(state, { collection, model }) {
            let fn = (model) => {
                let index = state[collection].findIndex(_model => _model.id === model.id)
                if (index >= 0) {
                    Vue.set(state[collection], index, model)
                } else {
                    state[collection].push(model)
                }
            }
    
            if (model instanceof Array) {
                model.forEach(fn)
            } else {
                fn(model)
            }
        },
        delete(state, { collection, id }) {
            let index = state[collection].findIndex(model => model.id === id)
            if (index >= 0) {
                state[collection].splice(index, 1)
            }
        },
        empty(state, { collection }) {
            Vue.set(state, collection, [])
        },
    }
}